package cn.bunny.user.controller;

import cn.bunny.common.spzx.model.vo.common.Result;
import cn.bunny.common.spzx.model.vo.common.ResultCodeEnum;
import cn.bunny.user.service.SmsService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Tag(name = "发送验证码")
@RestController
@RequestMapping("/api/user/sms")
public class SmsController {
    @Resource
    private SmsService smsService;

    @GetMapping(value = "/sendCode/{phone}")
    @Operation(summary = "短信验证码", operationId = "发送短信验证码")
    public Result sendValidateCode(@PathVariable("phone") String phone) {
        return Result.build(smsService.sendCode(phone), ResultCodeEnum.SUCCESS);
    }
}
