package cn.bunny.user.service.impl;

import cn.bunny.common.HttpUtils;
import cn.bunny.user.service.SmsService;
import com.alibaba.nacos.common.utils.StringUtils;
import jakarta.annotation.Resource;
import org.apache.commons.lang3.RandomStringUtils;
import org.apache.http.HttpResponse;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.TimeUnit;

@Service
public class SmsServiceImpl implements SmsService {
    @Resource
    private RedisTemplate redisTemplate;

    // 短信验证码
    @Override
    public Object sendCode(String phone) {
        Object code = redisTemplate.opsForValue().get(phone);
        if (StringUtils.hasText((String) code)) {
            return code;
        }

        // 1.生成短信验证码
        code = RandomStringUtils.randomNumeric(4);
        // 2.放入Redis中，设置过期时间
        redisTemplate.opsForValue().set(phone, code, 5, TimeUnit.MINUTES);
        // 3. 向手机号发送短信验证码
        sendMessage(phone, (String) code);

        return code;
    }

    // 发送验证码
    private void sendMessage(String phone, String code) {
        String host = "https://dfsns.market.alicloudapi.com";
        String path = "/data/send_sms";
        String method = "POST";
        String appcode = "5a4cb12374904a7fa2975ec5a1a9d50f";
        Map<String, String> headers = new HashMap<String, String>();
        headers.put("Authorization", "APPCODE " + appcode);
        // 根据API的要求，定义相对应的Content-Type
        headers.put("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
        Map<String, String> querys = new HashMap<String, String>();
        Map<String, String> bodys = new HashMap<String, String>();
        bodys.put("content", "code:" + code);
        bodys.put("template_id", "CST_ptdie100");  // 该模板为调试接口专用，短信下发有受限制，调试成功后请联系客服报备专属模板
        bodys.put("phone_number", phone);


        try {
            HttpResponse httpResponse = HttpUtils.doPost(host, path, method, headers, querys, bodys);
            System.out.println(httpResponse.toString());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
